###############################################
#         AM TclMagick Wrapper Library        #
# Requires: TclMagick                         #
#                                             #
###############################################


proc am_trim_image {srcImgFileName dstImgFileName {colorDiffTolerance 10}} {
#
# Original Author: Alex Nisenboim
# Last Modified By: Alex Nisenboim
# Last Modified: 2011-09-12
#
# Usage  :  am_trim_image srcImgFileName dstImgFileName ?colorDiffTolerance?
#
# Synopis: 
# 
# Input  : 
#
# Note   : 
#
    set imgWand [magick create wand]
    $imgWand ReadImage $srcImgFileName
    $imgWand TrimImage $colorDiffTolerance
    $imgWand WriteImage $dstImgFileName
    magick delete $imgWand
}

proc am_resize_image {srcImgFileName dstImgFileName width height} {
#
# Original Author: Alex Nisenboim
# Last Modified By: Alex Nisenboim
# Last Modified: 2011-09-12
#
# Usage  :  am_resize_image srcImgFileName dstImgFileName width height
#
# Synopis: 
# 
# Input  : 
#
# Note   : 
#       
    set imgWand [magick create wand]
    $imgWand ReadImage $srcImgFileName
    $imgWand ResizeImage $width $height triangle
    $imgWand WriteImage $dstImgFileName
    magick delete $imgWand
}

proc am_append_images {srcImgFileNamesList dstImgFileName {isVertcalAppend 1}} {
#
# Original Author: Alex Nisenboim
# Last Modified By: Alex Nisenboim
# Last Modified: 2011-09-12
#
# Usage  :  am_append_images srcImgFileNames dstImgFileName ?isVertcalAppend 1?
#
# Synopis: 
# 
# Input  : 
#
# Note   : 
#           
   set imgAccumulatorWand [magick create wand]
   foreach srcImgFileName $srcImgFileNamesList {
       _am_add_image_to_wand_object imgAccumulatorWand $srcImgFileName       
   }
   set wand [$imgAccumulatorWand AppendImages $isVertcalAppend]
   $wand WriteImage $dstImgFileName
   magick delete $wand
   magick delete $imgAccumulatorWand
}

proc _am_add_image_to_wand_object {inputImgWandVar srcImgFileName} {
#
# Original Author: Alex Nisenboim
# Last Modified By: Alex Nisenboim
# Last Modified: 2011-09-12
#
# Usage  :  _am_add_image_to_wand_object inputImgWand srcImgFileName 
#
# Synopis: 
# 
# Input  : 
#
# Note   : 
#
   upvar 1 $inputImgWandVar inputImgWand
   set imgWand [magick create wand]
   $imgWand ReadImage $srcImgFileName
   $inputImgWand AddImage $imgWand
   magick delete $imgWand
}
